function [t,y] = adaptHeun(f,t0,T,y0,h0,atol,rtol)

% function adaptHeun
%
% Zweck: integriere die gewoehnliche Diff.-Gleichung erster Ordnung
%
%          dy/dt = f(t,y(t))
%
%        mit einem (zu?) einfachen adaptiven Heun Verfahren mit
%        Schrittweitenhalbierung-Fehlerschaetzer.
%
% Parameters: f    ... rechte Seite f(t,y(t)) der gew. Diff.-Gl.
%             t0,T ... Start- und End-Zeit
%             y0   ... Anfagswert
%             h0   ... Anfangs-Schrittweite
%             atol ... Absolute Toleranz
%             rtol ... Relative Toleranz
%
% Returns: t ... Zeiten
%          y ... approx. Loesung zu Zeiten t
%
% Notes: Keine.
%

% Parameter
  p = 2;         % KO des Heun Verfahren
  hmin = 10*eps; % kleinste zugelassene Schrittweite
  fac = 0.9;     % Sicherheits-Faktor
  facmin = 0.5;  % kleinste zugelassene Schrittweiten-Verkleinerung
  facmax = 1.5;  % groesste zugelassene Schrittweiten-Vergroesserung

% Initialisiere Zeit- und Loesungs-Vektor
  t = t0;
  y = y0;
